
;;; //////////////////////////////////////////////////////////////////
;;; 
;;; CAPITOL 5 & 8
;;;                
;;; Generarea faptelor
;;; Fisier gen-fapte.lsp
;;;
;;;                                
;;;///////////////////////////////////////////////////////////////////


 
(defun gen-fapte-aux (scop subst lista-fapte)
   (if (null lista-fapte)
      (make-stream-vid)
      (let ((match (unifica scop (FAPT-info (obtine-asert (car lista-fapte))) subst)))
         (if (equal match 'insucces)
            (gen-fapte-aux scop subst (cdr lista-fapte))
            (cons-stream
             match
             (gen-fapte-aux scop subst (cdr lista-fapte)))))))
            

(defun gen-fapte (scop substitutii)
   "Generates the substitution stream resulted from the
unification of scop with all fapte"
   (gen-fapte-aux scop substitutii *LISTA-FAPTE*))