;;///////////////////////////////////////////////////////////////
;;
;;3 Strategii de cautare
;;3.1 Strategii de cautare neinformata
;;3.1.2 Backtracking
;;
;;//////////////////////////////////////////////////////////////

;;"bkt.lsp" - generarea caii la o solutie, folosind backtracking

(defparameter *STFINALE* '(18 10 14))

(defparameter *LIM* 10)

(defparameter *SOLUTII* nil)

(defun estescopbkt (x) (member x *STFINALE*))

(defun succf(x)
	(if (< x *LIM*) (list (* 2 x) (+ 1 (* 2 x)))))

;;functie ce afiseaza toate solutiile
(defun bkt (stari)
	(format t "~& bkt: ~a" stari)
	(cond ((null stari) nil)
              ((estescopbkt (first stari)) 
	       (format t "~& SOLUTII:   ~a" stari))
	      (t (dolist (urm (succf (first stari)))
		   (bkt (cons urm stari))))))

;;functie ce memoreaza toate solutiile in lista *SOLUTII*
(defun bkt1 (stari)
	(cond ((null stari) nil)
	      ((estescopbkt (first stari))
	       (push stari *SOLUTII*))
	      (t (dolist (urm (succf (first stari)))
		   (bkt1 (cons urm stari))))))

;;functie ce se opreste dupa ce a gasit o solutie
(defun bkt2 (stari)
	(format t "~& bkt: ~a" stari)
	(cond ((null stari) nil)
		((estescopbkt (first stari)) 
		 (format t "~& SOLUTII:   ~a" stari) 1 )
	      (t  (do ((indicator nil) 
		       (succesor (succf (first stari)) (rest succesor)))
		      ((null succesor) indicator)
                    (if (bkt2 (cons (first succesor) stari))
                       (progn
		          (setf succesor '())
			  (setf indicator 1)   
                          1)
                        nil ))))) 

(defun rezbkt (init)
	(bkt1 (list init))
	(dolist (solutie (reverse *SOLUTII*))
	  (format t "~& ~a" solutie)))

;;Exemple de apel
(bkt (list 1))
(rezbkt 1)
(bkt2 (list 1))