;;////////////////////////////////////////////////////
;;
;; CAPITOLUL 5 & 8
;;
;; Motor de inferenta bazat pe evaluare intarziata
;;
;; Manipularea regulilor
;; fisier rules.lsp
;;
;;///////////////////////////////////////////////////


(defstruct regula 
                 id
                 premize
                 concluzie)

(defun premize (regula)
   "Intoarce premizele regulii"
   (regula-premize regula))

(defun concluzie (regula)
   "Intoarce concluzia regulii"
   (regula-concluzie regula))

(defun conj-premize-p (premize)
   (equal (first premize) 'and))

(defun regula-adauga-premize (regula premize-noi)
   "Adauga noi premize la regula"
   (let* ((premize (regula-premize regula))
          (premize-res (append premize
                          (list premize-noi))))
      (if (conj-premize-p premize)
         (setf (regula-premize regula) premize-noi)
         (setf (regula-premize regula)
                (append premize-noi '(and))))))
      

(defun print-o-premiza (premiza)
   (format t "~&~T ~a" premiza))


(defun print-regula (regula)
   "Scrie indentat o regula"
   (format t "~&regula : ~%~T IF ~a ~%~T THEN ~a ~%"
      (premize regula) (concluzie regula)))