;; /////////////////////////////////////////////////////////////////
;;
;; CAPITOL 2
;;
;; Filtrarea unei liste
;; isier filter.lsp
;;
;;////////////////////////////////////////////////////////////////////

(defun filter (fn lst)
   "Pastreaza toate elem din lst care satisfac fn"
	(let ((acc nil))
		(dolist (x lst)
			(let ((val (funcall fn x)))
			  (if val (push val acc))))
		(nreverse acc)))

;; Exemplu apel
;; Eliminarea numerelor impare
;; (filter #'(not evenp) '(1 2 3 4 5 6 7))
