;;/////////////////////////////////////////////////////////////////
;;
;;3 Strategii de cautare
;;3.1 Strategii de cautare neinformata
;;3.1.3 Cautarea pe nivel
;;
;;/////////////////////////////////////////////////////////////////

;; "nivel.lsp" - functie de cautare ce primeste ca parametri felul cautarii
;;(pe nivel sau in adancime)

(defparameter *FINAL* 18)
(defparameter *STFINALE* '(18 10 14))
(defparameter *LIM* 10)
(defparameter *SOLUTII* nil)

(defun estescop (x) (equal x *FINAL*))

(defun succf(x) (if (< x *LIM*) (list (* 2 x) (+ 1 (* 2 x)))))

(defun caut (stari scop succesori strategie)
;; caut este o functie generala care primeste ca parametru strategia dorita. 
(format t "~& CAUT: ~a" stari)
(cond ((null stari) nil)
      ((funcall scop (first stari)) (first stari))
      (t (caut (funcall strategie
			 (funcall succesori (first stari)) (rest stari))
               scop succesori strategie))))

(defun la_urma (succesori FRONTIERA)
	(append FRONTIERA succesori))


(defun cautadanc (init scop succesori)
	(caut (list init) scop succesori #'append))

(defun cautlat (init scop succesori)
	(caut (list init) scop succesori #'la_urma))


;;Exemple de apel
(cautadanc 1 #'estescop #'succf)
(cautlat 1 #'estescop #'succf)
